STRICT = true
DEBUG = true

require 'zoetrope'
deque = require 'deque'
--inspect = require 'inspect'
require 'sprite'

require 'util'
require 'version'
require 'player'
require 'clone'

GameView = View:extend {
   onNew = function (self)
              self:loadLayers('data/map.lua')

              local tw = math.floor(the.app.width / 16)
              local th = math.floor(the.app.height / 16)

              the.player = Player:new{
                 x = math.random(2, tw-2) * 16,
                 y = math.random(2, th-2) * 16
              }
              self:add(the.player)

              the.clones = Group:new()
              self:add(the.clones)
              for _ = 1, 15 do
                 the.clones:add(Clone:new {
                                   x = math.random(2, tw-2) * 16,
                                   y = math.random(2, th-2) * 16
                                })
              end
           end,
   onUpdate = function(self, dt)
                 if the.player.moved then
                    -- this should encapsulate
                    for _, np in ipairs(the.clones.sprites) do
                       np:doMove()
                    end

                    the.clones:collide(self.map)
                    the.player:collide(self.map)

                    the.clones:collide()
                    the.clones:collide(the.player)

                    the.player.moved = false
                 end

                 if the.keys:justPressed('escape', 'q') then
                    the.app:quit()
                 end
              end,
}

the.app = App:new {
   name = "LD28",
   onRun = function (self)
              print('Version: ' .. VERSION)

              self.view = GameView:new()

              if DEBUG then
                 self.console:watch('VERSION', 'VERSION')

                 -- back off that dark overlay a bit
                 self.console.fill.fill[4] = 75
              end
           end,
   onUpdate = function (self, dt)
                 if the.keys:justPressed('f1') then
                    local ss = love.graphics.newScreenshot()
                    ss:encode('screenshot-' ..love.timer.getTime()..'.png')
                 end
              end
}
